diff -urN sourceold/scripts/jfwdef.h source/scripts/jfwdef.h
--- sourceold/scripts/jfwdef.h	2018-10-27 22:04:56.456400000 +1000
+++ source/scripts/jfwdef.h	2020-09-10 09:08:27.964852500 +1000
@@ -19,7 +19,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -47,7 +46,6 @@
 	unsigned int objtype;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -72,7 +70,6 @@
 	unsigned int objtype;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -97,7 +94,6 @@
 	unsigned int objtype;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -119,7 +115,6 @@
 	bool primary;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -144,7 +139,6 @@
 	bool primary;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -169,7 +163,6 @@
 	bool primary;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -189,7 +182,6 @@
 	bool attack;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -209,7 +201,6 @@
 	bool attack;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -228,7 +219,6 @@
 	bool attack;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -248,7 +238,6 @@
 	bool primary;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -268,7 +257,6 @@
 	bool primary;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -288,7 +276,6 @@
 	bool primary;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -309,7 +296,6 @@
 	unsigned int objtype;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -342,7 +328,6 @@
 	unsigned int objtype;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -364,7 +349,6 @@
 	bool primary;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -386,7 +370,6 @@
 	bool primary;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -405,7 +388,6 @@
 	bool attack;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -424,7 +406,6 @@
 	bool attack;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -445,7 +426,6 @@
 	bool primary;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -466,7 +446,6 @@
 	bool primary;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -476,7 +455,6 @@
 	bool attack;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -486,7 +464,6 @@
 	bool attack;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -496,7 +473,6 @@
 	bool attack;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -507,7 +483,6 @@
 	bool primary;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -518,7 +493,6 @@
 	bool primary;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -529,7 +503,6 @@
 	bool primary;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -539,7 +512,6 @@
 	bool attack;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -549,7 +521,6 @@
 	bool attack;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -560,7 +531,6 @@
 	bool primary;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -571,7 +541,6 @@
 	bool primary;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -585,7 +554,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -599,7 +567,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -613,7 +580,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -625,7 +591,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -637,7 +602,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -649,7 +613,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -663,7 +626,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -677,7 +639,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -689,7 +650,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -701,7 +661,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -713,7 +672,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -725,7 +683,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -737,7 +694,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -749,7 +705,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -761,7 +716,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
diff -urN sourceold/scripts/jfwdmg.cpp source/scripts/jfwdmg.cpp
--- sourceold/scripts/jfwdmg.cpp	2018-11-17 10:23:57.202600000 +1000
+++ source/scripts/jfwdmg.cpp	2020-03-28 21:10:59.029816200 +1000
@@ -15,6 +15,7 @@
 #include "engine.h"
 #include "jfwdmg.h"
 #include "BuildingGameObj.h"
+#include "SoldierGameObj.h"
 #include "VehicleGameObjDef.h"
 
 void JFW_Spawn_Object_Death::Killed(GameObject *obj,GameObject *killer)
@@ -1033,6 +1034,8 @@
 	INIClass *config = Get_INI(Get_Parameter("ConfigFile"));
 	count = config->Get_Int("PresetNames","PresetNameCount",0);
 	messages = new KillMessage[count];
+	KillerIsMSBot = false;
+	KilledIsMSBot = false;
 	char preset[50];
 	char c[50];
 	for (int i = 0;i < count;i++)
@@ -1056,21 +1059,37 @@
 	}
 	if (type == Get_Int_Parameter("Message"))
 	{
+		KillerIsMSBot = false;
+		KilledIsMSBot = false;
+
 		if (Commands->Is_A_Star(sender))
 		{
 			KilledID = 0;
 			KilledPlayerID = Get_Player_ID(sender);
 		}
+		else if (sender->As_SoldierGameObj() && sender->As_SoldierGameObj()->Is_Bot())
+		{
+			KilledID = 0;
+			KilledPlayerID = sender->Get_ID();
+			KilledIsMSBot = true;
+		}
 		else if (sender->As_VehicleGameObj() && (Get_Vehicle_Driver(sender)))
 		{
 			KilledID = Commands->Get_Preset_ID(sender);
-			KilledPlayerID = Get_Player_ID(Get_Vehicle_Driver(sender));
+			if (Get_Vehicle_Driver(sender)->As_SoldierGameObj()->Is_Bot())
+			{
+				KilledIsMSBot = true;
+				KilledPlayerID = Get_Vehicle_Driver(sender)->Get_ID();
+			}
+			else
+				KilledPlayerID = Get_Player_ID(Get_Vehicle_Driver(sender));
 		}
 		else
 		{
 			KilledID = Commands->Get_Preset_ID(sender);
 			KilledPlayerID = 0;
 		}
+
 		GameObject *Killer = Commands->Find_Object(param);
 		GameObject *explosion = GetExplosionObj();
 		if (!explosion || (explosion->As_VehicleGameObj() && Get_Vehicle_Mode(explosion) != VEHICLE_TYPE_TURRET))
@@ -1085,6 +1104,12 @@
 				KillerPlayerID = Get_Player_ID(Killer);
 				KillerTeam = Get_Object_Type(Killer);
 			}
+			else if (Killer->As_SoldierGameObj()->Is_Bot())
+			{
+				KillerIsMSBot = true;
+				KillerPlayerID = Killer->Get_ID();
+				KillerTeam = Get_Object_Type(Killer);
+			}
 			else
 			{
 				KillerPlayerID = 0;
@@ -1108,7 +1133,14 @@
 			KillerTeam = Get_Object_Type(Killer);
 			if (Get_Vehicle_Gunner(Killer))
 			{
-				KillerPlayerID = Get_Player_ID(Get_Vehicle_Gunner(Killer));
+				if (Get_Vehicle_Gunner(Killer)->As_SoldierGameObj()->Is_Bot())
+				{
+					KillerIsMSBot = true;
+					KillerPlayerID = Get_Vehicle_Gunner(Killer)->Get_ID();
+				}
+				else
+					KillerPlayerID = Get_Player_ID(Get_Vehicle_Gunner(Killer));
+
 				KillerTeam = Get_Object_Type(Get_Vehicle_Gunner(Killer));
 			}
 			else
@@ -1127,7 +1159,14 @@
 	}
 	else if (type == CUSTOM_EVENT_VHEICLE_DRIVER_ID)
 	{
-		KillerPlayerID = Get_Player_ID(Commands->Find_Object(param));
+		if (Commands->Find_Object(param)->As_SoldierGameObj()->Is_Bot())
+		{
+			KillerIsMSBot = true;
+			KillerPlayerID = param;
+		}
+		else
+			KillerPlayerID = Get_Player_ID(Commands->Find_Object(param));
+
 		KillerTeam = Get_Object_Type(Commands->Find_Object(param));
 	}
 	else
@@ -1168,7 +1207,10 @@
 	}
 	if (KilledPlayerID)
 	{
-		KilledPlayerString = Get_Player_Name_By_ID(KilledPlayerID);
+		if (KilledIsMSBot)
+			KilledPlayerString = Get_Player_Name(Commands->Find_Object(KilledPlayerID));
+		else
+			KilledPlayerString = Get_Player_Name_By_ID(KilledPlayerID);
 	}
 	else
 	{
@@ -1176,7 +1218,10 @@
 	}
 	if (KillerPlayerID)
 	{
-		KillerPlayerString = Get_Player_Name_By_ID(KillerPlayerID);
+		if (KillerIsMSBot)
+			KillerPlayerString = Get_Player_Name(Commands->Find_Object(KillerPlayerID));
+		else
+			KillerPlayerString = Get_Player_Name_By_ID(KillerPlayerID);
 	}
 	else
 	{
diff -urN sourceold/scripts/jfwdmg.h source/scripts/jfwdmg.h
--- sourceold/scripts/jfwdmg.h	2018-11-17 10:23:57.202600000 +1000
+++ source/scripts/jfwdmg.h	2020-03-28 21:10:59.030813100 +1000
@@ -420,6 +420,8 @@
 	unsigned int KillerPlayerID;
 	unsigned int KilledID;
 	unsigned int KilledPlayerID;
+	bool KillerIsMSBot;
+	bool KilledIsMSBot;
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 public:
diff -urN sourceold/scripts/jfwscr.cpp source/scripts/jfwscr.cpp
--- sourceold/scripts/jfwscr.cpp	2018-11-17 10:23:57.216600000 +1000
+++ source/scripts/jfwscr.cpp	2020-03-30 20:42:37.441278900 +1000
@@ -274,6 +274,31 @@
 	}
 }
 
+void JFW_Attach_Script_Custom_Until_Custom::Custom(GameObject *obj, int type, int param, GameObject *sender)
+{
+	if (type == Get_Int_Parameter("AttachMessage"))
+	{
+		const char *script = Get_Parameter("Script");
+		const char *paramx = Get_Parameter("Params");
+		char *params = newstr(paramx);
+		char delim = Get_Parameter("Delim")[0];
+		size_t x = strlen(params);
+		for (size_t i = 0; i < x; i++)
+		{
+			if (params[i] == delim)
+			{
+				params[i] = ',';
+			}
+		}
+		Commands->Attach_Script(obj, script, params);
+		delete[] params;
+	}
+	else if (type == Get_Int_Parameter("RemoveMessage"))
+	{
+		Remove_Script(obj, Get_Parameter("Script"));
+	}
+}
+
 void JFW_Remove_All_Scripts_Custom::Custom(GameObject *obj,int type,int param,GameObject *sender)
 {
 	if (type == Get_Int_Parameter("Message"))
@@ -484,6 +509,7 @@
 ScriptRegistrant<JFW_Remove_Script_Custom> JFW_Remove_Script_Custom_Registrant("JFW_Remove_Script_Custom","Script:string,Message:int");
 ScriptRegistrant<JFW_Remove_Script_Death> JFW_Remove_Script_Death_Registrant("JFW_Remove_Script_Death","Script:string");
 ScriptRegistrant<JFW_Attach_Script_Custom> JFW_Attach_Script_Custom_Registrant("JFW_Attach_Script_Custom","Script:string,Params:string,Delim:string,Message:int");
+ScriptRegistrant<JFW_Attach_Script_Custom_Until_Custom> JFW_Attach_Script_Custom_Until_Custom_Registrant("JFW_Attach_Script_Custom_Until_Custom","Script:string,Params:string,Delim:string,AttachMessage:int,RemoveMessage:int");
 ScriptRegistrant<JFW_Remove_All_Scripts_Custom> JFW_Remove_All_Scripts_Custom_Registrant("JFW_Remove_All_Scripts_Custom","Message:int");
 ScriptRegistrant<JFW_Attach_Script_Preset_Once_Custom> JFW_Attach_Script_Preset_Once_Custom_Registrant("JFW_Attach_Script_Preset_Once_Custom","Script:string,Params:string,Delim:string,Message:int,Preset:string,Player_Type:int");
 ScriptRegistrant<JFW_Attach_Script_Type_Once_Custom> JFW_Attach_Script_Type_Once_Custom_Registrant("JFW_Attach_Script_Type_Once_Custom","Script:string,Params:string,Delim:string,Message:int,Type:int,Player_Type:int");
diff -urN sourceold/scripts/jfwscr.h source/scripts/jfwscr.h
--- sourceold/scripts/jfwscr.h	2018-11-17 10:23:57.217600000 +1000
+++ source/scripts/jfwscr.h	2020-03-30 20:42:37.442276500 +1000
@@ -63,6 +63,11 @@
   void Custom(GameObject *obj,int type,int param,GameObject *sender);
 };
 
+class JFW_Attach_Script_Custom_Until_Custom : public ScriptImpClass
+{
+  void Custom(GameObject *obj, int type, int param, GameObject *sender);
+};
+
 class JFW_Remove_All_Scripts_Custom : public ScriptImpClass {
 	void Custom(GameObject *obj,int type,int param,GameObject *sender);
 };
diff -urN sourceold/scripts/jfwws.cpp source/scripts/jfwws.cpp
--- sourceold/scripts/jfwws.cpp	2018-11-17 10:23:57.224600000 +1000
+++ source/scripts/jfwws.cpp	2020-09-10 09:08:27.965610500 +1000
@@ -13,6 +13,7 @@
 
 #include "scripts.h"
 #include "jfwws.h"
+#include "engine_tt.h"
 
 void JFW_Building_Explode_No_Damage::Killed(GameObject *obj,GameObject *killer)
 {
@@ -236,7 +237,10 @@
 	if ((Get_Int_Parameter("Frequency_Min") != -1) && (type == CUSTOM_EVENT_SOUND_ENDED))
 	{
 		float random = Commands->Get_Random(Get_Float_Parameter("Frequency_Min"),Get_Float_Parameter("Frequency_Max"));
-		Commands->Start_Timer(obj,this,random,0);
+		if(!Has_Timer(obj,this,0))
+		{
+			Commands->Start_Timer(obj,this,random,0);
+		}
 	}
 }
 
@@ -714,6 +718,7 @@
 ScriptRegistrant<JFW_Enable_Physical_Collision> JFW_Enable_Physical_Collision_Registrant("JFW_Enable_Physical_Collision","");
 ScriptRegistrant<JFW_DestroyedStateObject> JFW_DestroyedStateObject_Registrant("JFW_DestroyedStateObject","OriginalModelFacing:float,DestroyedModelPreset:string");
 ScriptRegistrant<JFW_Play_Sound> JFW_Play_Sound_Registrant("JFW_Play_Sound","Sound_Preset:string,Is_3D=1:int,Offset:vector3,Offset_Randomness:vector3,Frequency_Min=-1:float,Frequency_Max:float");
+ScriptRegistrant<JFW_Play_Sound> M00_Play_Sound_Registrant("M00_Play_Sound","Sound_Preset:string,Is_3D=1:int,Offset:vector3,Offset_Randomness:vector3,Frequency_Min=-1:float,Frequency_Max:float");
 ScriptRegistrant<JFW_Engine_Sound> JFW_Engine_Sound_Registrant("JFW_Engine_Sound","Preset:string,Bone:string");
 ScriptRegistrant<JFW_Mobius_Script> JFW_Mobius_Script_Registrant("JFW_Mobius_Script","");
 ScriptRegistrant<JFW_Mobius_Script> Dr_Mobius_Script_Registrant("Dr_Mobius_Script","");
